# Contribution Guide

The purpose of this document is to make it easier for new contributors to get up-to-speed on the project.

## Prerequisites

In order to contribute to this project you need to be familiar with Elm and understand some language processing / compiler concepts that are core to Morphir. 
We collected a series of learning materials for you to make it easier to fill any knowledge gaps. Feel free to skip any of these if you feel like you are an expert. 
If you have any doubts though it's better to glance through them. We included the length of each video so that you understand the amount of effort involved.

- Programming in Elm
  - Language Overview
    - [Official language guide](https://guide.elm-lang.org/)
    - [Quick overview of Elm with comparisons to JavaScript](https://www.youtube.com/watch?v=um0jxfgboNo) (10 mins)
    - [Longer overview with a focus on how Elm makes your app more reliable](https://www.youtube.com/watch?v=kEitFAY7Gc8) (45 mins)
  - Working with Types
    - [Chapter on Types from the official language guide](https://guide.elm-lang.org/types/)
    - [Elm type system basics](https://www.youtube.com/watch?v=F_bx2J8En9w) (2 mins)
    - [Algebraic Data Types](https://www.youtube.com/watch?v=JYWJzaiCtEw) (10 mins)
    - [Deeper dive into how types can help you](https://www.youtube.com/watch?v=memIRXFSNkU) (30 mins)
- Language processing
  - Abstract Syntax Trees
    - [Intro](https://www.youtube.com/watch?v=jpfaXK4xCYE) (3 mins)
    - [Deeper dive](https://www.youtube.com/watch?v=VKM1eLoN-gI) (12 mins)


## Project Setup

TODO
